clear all;clc;
%% System Information
global Q11 Q22 Q33 Q44 R11 R22 R33 R44 g1 g2 g3 g4;
global e12 e14 e21 e23 e32 e41 R12 R14 R21 R23 R32 R41;
global a b1 b2 b3 b4 d1 d2 d3 d4;
global w1 w2 w3 w4;

a=[0.995 0.09983;-0.09983 0.995];
b1=[0.2047;0.08984];b2=[0.2147;0.2895];b3=[0.2097;0.1897];b4=[0.2;0.1];

g1=0;g2=0;g3=0;g4=1;

R11=1;R22=1;R33=1;R44=1;

e12=0.8; e14=0.7;    e13=0;    e21=0;     e23=0.6;   e31=0.8;    e32=0;               e41=0;
R12=1;   R14=1;      R13=0;    R21=0;     R23=1;     R31=1;      R32=0;               R41=0;

Q11=eye(2);Q22=eye(2);Q33=eye(2);Q44=eye(2);

EE=[0    e12  e13  e14
    e21  0    e23  0
    e31  e32  0    0
    e41  0    0    0 ];
di=EE*[1;1;1;1];
d1=di(1);d2=di(2);d3=di(3);d4=di(4);
Di=blkdiag(d1,d2,d3,d4);
LG=Di-EE+blkdiag(g1,g2,g3,g4);
A=blkdiag(a,a,a,a);
B=blkdiag(b1,b2,b3,b4);
R=blkdiag(R11,R22,R33,R44);
g=blkdiag((g1+d1),(g2+d2),(g3+d3),(g4+d4));
ff=.01;
s1=rand(7,7);s2=rand(5,5);s3=rand(5,5);s4=rand(3,3);
w1=ff*(s1'*s1);
w2=ff*(s2'*s2);
w3=ff*(s3'*s3);
w4=ff*(s4'*s4);

x(:,1)=1.5*rand(8,1);x0(:,1)=rand(2,1);
x0bar=kron([1;1;1;1],eye(2))*x0(:,1);Z(:,1)=-(kron(LG,eye(2)))*(x-x0bar); % varepsilon
x1(:,1)=Z(1:2,1);x2(:,1)=Z(3:4,1);x3(:,1)=Z(5:6,1);x4(:,1)=Z(7:8,1);
x10=[x1(:,1)' x2(:,1)' x4(:,1)'];
x20=[x2(:,1)' x3(:,1)'];
x30=[x1(:,1)' x3(:,1)'];
x40=[x4(:,1)'];

k=1;j=1;jj=1;
al=0.0001; xx=1;

 w1(7,7,1)=-1;w2(5,5,1)=-1;w3(5,5,1)=-1;w4(3,3,1)=-1;
 
 
 u1=-w1(7,1:6,1)*x10'/w1(7,7,1);u2=-w2(5,1:4,1)*x20'/w2(5,5,1);u3=-w3(5,1:4,1)*x30'/w3(5,5,1);u4=-w4(3,1:2,1)*x40'/w4(3,3,1);
for i=1:3000
    i;
    ww1=[w1(1,1);2*w1(1,2);2*w1(1,3);2*w1(1,4);2*w1(1,5);2*w1(1,6);2*w1(1,7);
                   w1(2,2);2*w1(2,3);2*w1(2,4);2*w1(2,5);2*w1(2,6);2*w1(2,7);
                             w1(3,3);2*w1(3,4);2*w1(3,5);2*w1(3,6);2*w1(3,7);
                                       w1(4,4);2*w1(4,5);2*w1(4,6);2*w1(4,7);
                                                 w1(5,5);2*w1(4,6);2*w1(5,7);
                                                           w1(6,6);2*w1(6,7);
                                                                     w1(7,7)];
                                                                                     
    ww2=[w2(1,1);2*w2(1,2);2*w2(1,3);2*w2(1,4);2*w2(1,5);
                   w2(2,2);2*w2(2,3);2*w2(2,4);2*w2(2,5);
                             w2(3,3);2*w2(3,4);2*w2(3,5);
                                       w2(4,4);2*w2(4,5);
                                                 w2(5,5)];                                                     

    ww3=[w3(1,1);2*w3(1,2);2*w3(1,3);2*w3(1,4);2*w3(1,5);
                   w3(2,2);2*w3(2,3);2*w3(2,4);2*w3(2,5);
                             w3(3,3);2*w3(3,4);2*w3(3,5);
                                       w3(4,4);2*w3(4,5);
                                                 w3(5,5)];                                                       
                                                                 
    ww4=[w4(1,1);2*w4(1,2);2*w4(1,3);
                   w4(2,2);2*w4(2,3);
                             w4(3,3)];                                                                                          

    XB1(i,:)=[x10(1)^2 x10(1)*x10(2) x10(1)*x10(3) x10(1)*x10(4) x10(1)*x10(5) x10(1)*x10(6) x10(1)*u1 x10(2)^2 x10(2)*x10(3) x10(2)*x10(4) x10(2)*x10(5) x10(2)*x10(6) x10(2)*u1 x10(3)^2 x10(3)*x10(4) x10(3)*x10(5) x10(3)*x10(6) x10(3)*u1 x10(4)^2 x10(4)*x10(5) x10(4)*x10(6) x10(4)*u1 x10(5)^2 x10(5)*x10(6) x10(5)*u1 x10(6)^2 x10(6)*u1 u1*u1];
    XB2(i,:)=[x20(1)^2 x20(1)*x20(2) x20(1)*x20(3) x20(1)*x20(4) x20(1)*u2 x20(2)^2 x20(2)*x20(3) x20(2)*x20(4) x20(2)*u2 x20(3)^2 x20(3)*x20(4) x20(3)*u2 x20(4)^2 x20(4)*u2 u2*u2];
    XB3(i,:)=[x30(1)^2 x30(1)*x30(2) x30(1)*x30(3) x30(1)*x30(4) x30(1)*u3 x30(2)^2 x30(2)*x30(3) x30(2)*x30(4) x30(2)*u3 x30(3)^2 x30(3)*x30(4) x30(3)*u3 x30(4)^2 x30(4)*u3 u3*u3];
    XB4(i,:)=[x40(1)^2 x40(1)*x40(2) x40(1)*u4 x40(2)^2 x40(2)*u4 u4*u4];        
    
    x0bar=kron([1;1;1;1],eye(2))*x0(:,i);
    x0(:,i+1)=a*x0(:,i);
    x1(:,i+1)=(a*x1(:,i))-((g1+d1)*b1*u1)+(e12*b2*u2)+(e13*b3*u3)+(e14*b4*u4);
    x2(:,i+1)=(a*x2(:,i))-((g2+d2)*b2*u2)+(e21*b1*u1)+(e23*b3*u3);
    x3(:,i+1)=(a*x3(:,i))-((g3+d3)*b3*u3)+(e31*b1*u1)+(e32*b2*u2);
    x4(:,i+1)=(a*x4(:,i))-((g4+d4)*b4*u4)+(e41*b1*u1);
    x(:,i+1)=[x1(:,i+1);x2(:,i+1);x3(:,i+1);x4(:,i+1)];
    XZ(:,i)=x0bar-(inv((kron(LG,eye(2))))*x(:,i));
    
    Y1(i)=0.5*((x1(:,i)'*Q11*x1(:,i))+(u1*R11*u1)+(u2*R12*u2)+(u3*R13*u3)+(u4*R14*u4));
    Y2(i)=0.5*((x2(:,i)'*Q22*x2(:,i))+(u2*R22*u2)+(u1*R21*u1)+(u3*R23*u3));
    Y3(i)=0.5*((x3(:,i)'*Q33*x3(:,i))+(u3*R33*u3)+(u1*R31*u1)+(u2*R32*u2));
    Y4(i)=0.5*((x4(:,i)'*Q44*x4(:,i))+(u4*R44*u4)+(u1*R41*u1));
   
    x10=[x1(:,i+1)' x2(:,i+1)' x4(:,i+1)'];
    x20=[x2(:,i+1)' x3(:,i+1)'];
    x30=[x1(:,i+1)' x3(:,i+1)'];
    x40=[x4(:,i+1)'];

    XA1(i,:)=[x10(1)^2 x10(1)*x10(2) x10(1)*x10(3) x10(1)*x10(4) x10(1)*x10(5) x10(1)*x10(6) x10(1)*u1 x10(2)^2 x10(2)*x10(3) x10(2)*x10(4) x10(2)*x10(5) x10(2)*x10(6) x10(2)*u1 x10(3)^2 x10(3)*x10(4) x10(3)*x10(5) x10(3)*x10(6) x10(3)*u1 x10(4)^2 x10(4)*x10(5) x10(4)*x10(6) x10(4)*u1 x10(5)^2 x10(5)*x10(6) x10(5)*u1 x10(6)^2 x10(6)*u1 u1*u1];
    XA2(i,:)=[x20(1)^2 x20(1)*x20(2) x20(1)*x20(3) x20(1)*x20(4) x20(1)*u2 x20(2)^2 x20(2)*x20(3) x20(2)*x20(4) x20(2)*u2 x20(3)^2 x20(3)*x20(4) x20(3)*u2 x20(4)^2 x20(4)*u2 u2*u2];
    XA3(i,:)=[x30(1)^2 x30(1)*x30(2) x30(1)*x30(3) x30(1)*x30(4) x30(1)*u3 x30(2)^2 x30(2)*x30(3) x30(2)*x30(4) x30(2)*u3 x30(3)^2 x30(3)*x30(4) x30(3)*u3 x30(4)^2 x30(4)*u3 u3*u3];
    XA4(i,:)=[x40(1)^2 x40(1)*x40(2) x40(1)*u4 x40(2)^2 x40(2)*u4 u4*u4];        

    XP1(i,:)=XB1(i,:)-XA1(i,:);
    XP2(i,:)=XB2(i,:)-XA2(i,:);
    XP3(i,:)=XB3(i,:)-XA3(i,:);
    XP4(i,:)=XB4(i,:)-XA4(i,:);

    if mod(i,28) == 0
        YY1(k)=Y1(i);
        XXP1(k,:)=XP1(i,:);

        WE1=ww1'-(al*(YY1-ww1'*XXP1')*XXP1');

        w1=[WE1(1)   WE1(2)/2   WE1(3)/2   WE1(4)/2   WE1(5)/2  WE1(6)/2  WE1(7)/2;
            WE1(2)/2 WE1(8)     WE1(9)/2   WE1(10)/2  WE1(11)/2 WE1(12)/2 WE1(13)/2;
            WE1(3)/2 WE1(9)/2   WE1(14)    WE1(15)/2  WE1(16)/2 WE1(17)/2 WE1(18)/2;
            WE1(4)/2 WE1(10)/2  WE1(15)/2  WE1(19)    WE1(20)/2 WE1(21)/2 WE1(22)/2;
            WE1(5)/2 WE1(11)/2  WE1(16)/2  WE1(20)/2  WE1(23)   WE1(24)/2 WE1(25)/2;
            WE1(6)/2 WE1(12)/2  WE1(17)/2  WE1(21)/2  WE1(24)/2 WE1(26)   WE1(27)/2;
            WE1(7)/2 WE1(13)/2  WE1(18)/2  WE1(22)/2  WE1(25)/2 WE1(27)/2 WE1(28)];
        u1=-1*inv(w1(7,7))*w1(7,1:6)*x10';
        k=1;
    else
        YY1(k)=Y1(i);
        XXP1(k,:)=XP1(i,:);
        k=k+1;
    end

    if mod(i,15) == 0
        YY2(j)=Y2(i);
        YY3(j)=Y3(i);
        XXP2(j,:)=XP2(i,:);
        XXP3(j,:)=XP3(i,:);
         WE2=ww2'-(al*(YY2-ww2'*XXP2')*XXP2');
         WE3=ww3'-(al*(YY3-ww3'*XXP3')*XXP3');

        w2=[WE2(1)   WE2(2)/2 WE2(3)/2  WE2(4)/2  WE2(5)/2 ;
            WE2(2)/2 WE2(6)   WE2(7)/2  WE2(8)/2  WE2(9)/2;
            WE2(3)/2 WE2(7)/2 WE2(10)   WE2(11)/2 WE2(12)/2;
            WE2(4)/2 WE2(8)/2 WE2(11)/2 WE2(13)   WE2(14)/2;
            WE2(5)/2 WE2(9)/2 WE2(12)/2 WE2(14)/2 WE2(15)];

        w3=[WE3(1)   WE3(2)/2 WE3(3)/2  WE3(4)/2  WE3(5)/2 ;
            WE3(2)/2 WE3(6)   WE3(7)/2  WE3(8)/2  WE3(9)/2;
            WE3(3)/2 WE3(7)/2 WE3(10)   WE3(11)/2 WE3(12)/2;
            WE3(4)/2 WE3(8)/2 WE3(11)/2 WE3(13)   WE3(14)/2;
            WE3(5)/2 WE3(9)/2 WE3(12)/2 WE3(14)/2 WE3(15)];
        
        u2=-1*inv(w2(5,5))*w2(5,1:4)*x20';
        u3=-1*inv(w3(5,5))*w3(5,1:4)*x30';
        j=1;
    else
        YY2(j)=Y2(i);
        YY3(j)=Y3(i);
        XXP2(j,:)=XP2(i,:);
        XXP3(j,:)=XP3(i,:);
        j=j+1;
    end
    if mod(i,6) == 0
        YY4(jj)=Y4(i);
        XXP4(jj,:)=XP4(i,:);
         WE4=ww4'-(al*(YY4-ww4'*XXP4')*XXP4');
        w4=[WE4(1)   WE4(2)/2  WE4(3)/2;
            WE4(2)/2 WE4(4)    WE4(5)/2;
            WE4(3)/2 WE4(5)/2  WE4(6)];
        u4=-1*inv(w4(3,3))*w4(3,1:2)*x40';
        jj=1;
    else
        YY4(jj)=Y4(i);
        XXP4(jj,:)=XP4(i,:);
        jj=jj+1;
    end
    
    wx1(:,:,i)=w1;
   wx2(:,:,i)=w2;
   wx3(:,:,i)=w3;
   wx4(:,:,i)=w4;
end
figure;
plot(2:i,XZ(:,2:i))
xlabel('Iteration Steps')
ylabel('Dynamics')
figure;
plot(XZ(1,2),XZ(2,2),'o-',XZ(3,2),XZ(4,2),'o-',XZ(5,2),XZ(6,2),'o-',XZ(7,2),XZ(8,2),'o-',XZ(1,3:i),XZ(2,3:i),XZ(3,3:i),XZ(4,3:i),XZ(5,3:i),XZ(6,3:i),XZ(7,3:i),XZ(8,3:i))
xlabel('Phase 1')
ylabel('Phase 2')
figure;
plot3(XZ(1,i:-1:2),XZ(2,i:-1:2),i:-1:2); hold on;
plot3(XZ(3,i:-1:2),XZ(4,i:-1:2),i:-1:2); hold on;
plot3(XZ(5,i:-1:2),XZ(6,i:-1:2),i:-1:2); hold on;
xlabel('Phase 1')
ylabel('Phase 2')
grid
figure;
plot(1:i+1,x1,1:i+1,x2,1:i+1,x3,1:i+1,x4)



o=1;
for j=2000:1:i
    x1j(:,o)=x1(:,j);x2j(:,o)=x2(:,j);x3j(:,o)=x3(:,j);x4j(:,o)=x4(:,j);
    xzj(:,o)=XZ(:,o);
    o=o+1;
end
figure;
plot(2:o-1,xzj(:,2:o-1))
xlabel('Iteration Steps')
ylabel('Dynamics')
legend('x_1_1','x_1_2','x_2_1','x_2_2','x_3_1','x_3_2','x_4_1','x_4_2')
figure;
plot(2:o-1,x1(:,2:o-1),2:o-1,x2(:,2:o-1),2:o-1,x3(:,2:o-1),2:o-1,x4(:,2:o-1))
xlabel('Iteration Steps')
ylabel('Tracking Error Dynamics')
legend('\epsilon_1','\epsilon_2','\epsilon_3','\epsilon_4','\epsilon_5','\epsilon_6','\epsilon_7','\epsilon_8')
figure;
plot3(XZ(1,o-1:-1:2),XZ(2,o-1:-1:2),o-1:-1:2,'r'); hold on;
plot3(XZ(3,o-1:-1:2),XZ(4,o-1:-1:2),o-1:-1:2,'g'); hold on;
plot3(XZ(5,o-1:-1:2),XZ(6,o-1:-1:2),o-1:-1:2,'y'); hold on;
plot3(XZ(7,o-1:-1:2),XZ(8,o-1:-1:2),o-1:-1:2); hold on;
xlabel('Phase 1')
ylabel('Phase 2')
legend('x_1_1,x_1_2','x_2_1,x_2_2','x_3_1,x_3_2','x_4_1,x_4_2')
grid
